Subject: bug#59786: Allowing arbitrary expressions in cl-labels

From: Stefan Monnier <[email-masked]>
Date: Wed, 13 Nov 2024 10:37:17 -0500

> | (cl-labels): Add support for (FUNC EXP) bindings (bug#59786)
> |
> | Allow `cl-labels` to use the same (FUNC EXP) bindings as were already added
> | to `cl-flet` in Emacs-25.  The Info doc (mistakenly) already documented this
> | new feature.
> |
> | * lisp/emacs-lisp/cl-macs.el (cl--self-tco-on-form): New function.
> | (cl-labels): Use it to add support for (FUNC EXP) bindings.
> |
> | * test/lisp/emacs-lisp/cl-macs-tests.el (cl-macs--labels): Add test for
> | tail-recursive (FUNC EXP) bindings.
>
> Thanks... but what happened to your `cl-lib-test-labels' ert test for
> "cl-lib-tests.el"?

I moved it to `cl-macs--labels` in `cl-macs-tests.el` after noticing
that this is where the other `cl-labels` tests were.

        Stefan